//******************************************************************************
// AUTEUR : Frederic Maleval & Jean-Pierre Planas
// DESCRIPTION : FRAMEWORK de test de monte en charge
//******************************************************************************
unit MC_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, ComCtrls, MC_ThreadClt;

type
  TfmVisu = class(TForm)
    SG_Resulat: TStringGrid;
    Panel1: TPanel;
    Label1: TLabel;
    L_Pause: TLabel;
    L_NbClientlMontee: TLabel;
    SE_NBClient: TSpinEdit;
    B_GO: TButton;
    PB_Progression: TProgressBar;
    Timer: TTimer;
    SG_Titres: TStringGrid;
    procedure B_GOClick(Sender: TObject);
    procedure Affiche;
    procedure TimerTimer(Sender: TObject);
    procedure EffaceGrille;
    procedure FormCreate(Sender: TObject);
  private
    TempsMax:DWORD; // = temps du thread qui a mis le plus de temps a avoir la reponse
    ListeClient: array of TThreadClient; // liste des threads
  end;

implementation

{$R *.DFM}

procedure TfmVisu.B_GOClick(Sender: TObject);
Var NbClient,i:Word;
begin
  TempsMax := 0;
  SG_Resulat.Color:=clWindow;
  EffaceGrille;
  SE_NBClient.enabled:=false;
  B_GO.enabled:=false;
  L_Pause.visible:=True;
  NbClient:=SE_NBClient.Value;
  SG_Resulat.RowCount:=NbClient;
  SetLength(ListeClient,NbClient);
  for i:= 0 to NbClient-1 do
  begin
    ListeClient[i]:=TThreadClient.GetThreadClientClass.Create(True);
    ListeClient[i].IndexThread:=i;
  end;
  for i:= 0 to NbClient-1 do ListeClient[i].Resume;
  TThreadClient.SetTempsDebut(GetTickCount);
  Timer.enabled:=true;
  PB_Progression.Visible:=True;
  PB_Progression.Max:=NbClient;
  PB_Progression.Position:=0;
  L_NbClientlMontee.caption:='0/'+IntToStr(NbClient);
  L_NbClientlMontee.Visible:=true;
end;

procedure TfmVisu.Affiche;
var NbClient,i:Word;
    Ok:Boolean;
begin
  NbClient:=SE_NBClient.Value;
  for i:= 0 to NbClient-1 do if ListeClient[i].Tag = 0 then //On utilise la proprit Tag pour savoir le Thread a affich son rsultat ou non
  begin
    if ListeClient[i].Stop then // si le thread a finit
    begin
      // Remplissage des colonnes
      SG_Resulat.Cells[0,i]:=IntToStr(i);
      SG_Resulat.Cells[1,i]:=ListeClient[i].ResultatRecu;
      SG_Resulat.Cells[2,i]:=ListeClient[i].ResultatAttendu;
      case ListeClient[i].Erreur of
        etNoError         : SG_Resulat.Cells[3,i]:='OK';
        etResultsDiffers  : SG_Resulat.Cells[3,i]:='Erreur';
        etException       : SG_Resulat.Cells[3,i]:='Exception';
      end;
      SG_Resulat.Cells[4,i]:=IntToStr(ListeClient[i].TempsExec )+ ' ms';
      SG_Resulat.Cells[5,i]:=IntToStr(ListeClient[i].TempsTotal)+ ' ms';
      // Calcul du tempsMax
      if ListeClient[i].TempsTotal>TempsMax then TempsMax:=ListeClient[i].TempsTotal;
      // Couleur de la stringGrids
      case ListeClient[i].Erreur of
        etNoError         : ;
        etResultsDiffers  : if SG_Resulat.Color<>clRed then SG_Resulat.Color:=$00BBBBFF;
        etException       : SG_Resulat.Color:=clRed;
      end;
      // On en a finit avec ce thread. Il n'aura plus  afficher de rsultat
      ListeClient[i].Tag:=1;
      // Affichage
      Application.ProcessMessages;
      PB_Progression.Position:=PB_Progression.Position+1;
      L_NbClientlMontee.caption:=IntToStr(PB_Progression.Position)+'/'+IntToStr(PB_Progression.Max);
    end;
  end;

  Ok:=True;
  for i:= 0 to NbClient-1 do if ListeClient[i].Tag <> 1 then Ok:=False;

  if Ok then
  begin
    Timer.enabled:=False;
    SE_NBClient.enabled:=True;
    B_GO.enabled:=True;
    L_Pause.visible:=False;
    L_NbClientlMontee.caption:=IntToStr(TempsMax)+' ms';
    PB_Progression.Visible:=False;
    application.ProcessMessages;
    // Maintenant on peut librer la mmoire
    for i:= 0 to NbClient-1 do ListeClient[i].Free;
    SetLength(ListeClient,0);
  end;
end;

procedure TfmVisu.TimerTimer(Sender: TObject);
begin
  application.ProcessMessages;
  Affiche;
end;

procedure TfmVisu.EffaceGrille;
var i,j:Byte;
begin
  for i:=0 to SG_Resulat.ColCount-1 do
    for j:=0 to SG_Resulat.RowCount-1 do SG_Resulat.Cells[i,j]:='';
end;

procedure TfmVisu.FormCreate(Sender: TObject);
begin
  // Affichage des titres
  SG_Titres.Cells[0,0]:='N du thread';
  SG_Titres.Cells[1,0]:='Res recu';
  SG_Titres.Cells[2,0]:='Res attendu';
  SG_Titres.Cells[3,0]:='Ok/Erreur ?';
  SG_Titres.Cells[4,0]:='Temps exec';
  SG_Titres.Cells[5,0]:='Temps total';
end;

end.
