unit UMCWizard;

interface

uses ToolsAPI,classes,windows,dialogs, URunWizard;

{//$r exp.res}

type TMCWizard=class(TInterfacedObject,
                      IOtaWizard,
                      IOtaRepositoryWizard,
                      IOTAProjectWizard)
        procedure AfterSave;
        { This function is called immediately before the item is saved. This is not
          called for IOTAWizard }
        procedure BeforeSave;
        { The associated item is being destroyed so all references should be dropped.
          Exceptions are ignored. }
        procedure Destroyed;
        { This associated item was modified in some way. This is not called for
          IOTAWizards }
        procedure Modified;

        function GetIDString: string;
        function GetName: string;
        function GetState: TWizardState;

        { Launch the AddIn }
        procedure Execute;

        function GetAuthor: string;
        function GetComment: string;
        function GetPage: string;
{$IFDEF Delphi5}
        function GetGlyph: HICON;
{$ELSE}
        function GetGlyph: cardinal;
{$ENDIF}
 end;

implementation

{ TMCWizard }

procedure TMCWizard.AfterSave;
begin
//
end;

procedure TMCWizard.BeforeSave;
begin
//
end;

procedure TMCWizard.Destroyed;
begin
//
end;

procedure TMCWizard.Execute;
begin
//  ShowMessage('Jpp Wizard');
  TMCWizardExec.RunWizard;
end;

function TMCWizard.GetAuthor: string;
begin
  Result:='Frdric Maleval & Jean-Pierre Planas';
end;

function TMCWizard.GetComment: string;
begin
  Result:='Gnrateur de clients de monte en charge';
end;


{$IFDEF Delphi5}
function TMCWizard.GetGlyph: HICON;
{$ELSE}
function TMCWizard.GetGlyph: Cardinal;
{$ENDIF}
begin
  Result:= LoadIcon(hInstance, 'ICONE');
end;

function TMCWizard.GetIDString: string;
begin
  Result:='JPP.ID.Wizard';
end;

function TMCWizard.GetName: string;
begin
  Result:='MC_Wizard';
end;

function TMCWizard.GetPage: string;
begin
  Result:='DERBY Wizard';
end;

function TMCWizard.GetState: TWizardState;
begin
  result := [wsEnabled];
end;

procedure TMCWizard.Modified;
begin

end;

end.
